// Tue Sep  3 12:14:29 MET DST 1996

// toDo:	- pass thru all text delegate methods (tryToPerformWith et.al.)
//			- font-height-change problems (introduce a needsRearanging-flag)
//			- add page-scroll buttons to scrollview similar to OmniWeb
//			- text moves around the pages only on a per line basis
//			- a new pageBreak should lie below the last line!
//			- wrong caretposition when pasting around or deleting chars right to a pagebreak.
//			- deleting of page break possible in rich-text (eg. the textWillChange-description)

#import "HTMLController.h"



char* MultiPageTextfilter(Text *self,unsigned char *insertText,int *insertLength,int position)
{	NXTextFilterFunc oldFunc=(NXTextFilterFunc)[[self delegate] oldTextFilter];

	if(oldFunc) return oldFunc(self,insertText,insertLength,position);
	else		return insertText;
}


//--------------------------------------------------------------------
@implementation Text(VarAdditions)

-(NXCoord) maxX {return maxX;}
-(NXCoord) maxY {return maxY;}

- becomeClass:aClass
{	self->isa = aClass;
	return [self initAdditionalIVars];
}

-(int) lengthOfLineForSel:(NXSelPt *)sel
{	return theBreaks->breaks[sel->line/sizeof(NXLineDesc)]&0x3fff;
}
-(int) charAt:(int) pos
{	char text[2];
	if([self getSubstring:text start:pos length:1] != 1) return 0;
	return text[0];
}

@end


// pagination override (Hidden and private)
@interface MultiPageText:Text
{}



-(BOOL) knowsPagesFirst:(int *)firstPageNum last:(int *)lastPageNum;
-(void) preventBreakSelectionUp:(int) off;
-(void) preventBreakSelectionUp:(int) off offset:(int)off1;
-(void) setDidKey:(MiscMPageText_t) flag;
-(void) setAutomoveBy:(int) i;
-(MiscMPageText_t) didKey;
@end


@implementation MultiPageText

-initAdditionalIVars
{	automoveBy=didKey=0;
	return self;
}


// pagination
-(BOOL) knowsPagesFirst:(int *)firstPageNum last:(int *)lastPageNum
{	*lastPageNum=[[self delegate] pageCount];
	return YES;
}
- (BOOL)getRect:(NXRect *)theRect forPage:(int)page
{	int				 i;
	NXCoord			 peekY,upperY=0;

	[self getFrame:theRect];
	for(i=0;i< page-1;i++)
	{	if((peekY=[[self delegate] heightForIndex:i])> 0) upperY+=peekY;
		else return NO;
	} if((peekY=[[self delegate] heightForIndex:MAX(page-1,0)])<= 0) return NO;
	theRect->origin.y=	upperY+(SEPERATOR_HEIGHT+1)*((page==1)? 0:1);
	theRect->size.height=peekY-(SEPERATOR_HEIGHT+1)*((page==1)? 0:1);

	return YES;
}

// selection handling
//	test whether images are affected by ''-test
//	(rewrite using pageBreakForY:sp.y)
-(BOOL) isPageBreakAt:(int) off
{
	return ([self charAt:off] == '');
}

-(void) preventBreakSelectionUp:(int) off offset:(int)off1
{	if(![window isFlushWindowDisabled] && (spN.cp-sp0.cp <2))
	{	if ([self isPageBreakAt:sp0.cp+off1])
			[self setSel:sp0.cp+off:sp0.cp+off];	// prevent selection of pageBreak
			[self makeSelectionVisible];
	}
}
-(void) preventBreakSelectionUp:(int) off
{	[self preventBreakSelectionUp:off offset:0];
}

- keyDown:(NXEvent *)theEvent;
{	int	old0=sp0.cp;
	[super keyDown:theEvent];

	if(automoveBy) {sp0.cp+=automoveBy,spN.cp+=automoveBy, automoveBy=0;}

	if(didKey == MiscMPageText_down) [self preventBreakSelectionUp:1 offset:-1];
	[self preventBreakSelectionUp:sp0.cp< old0? -1:2 offset:sp0.cp< old0?  0:0];
	[self setSel:sp0.cp:spN.cp];	// force caret-drawing
	didKey=0;						// final clearup
	return self;
}

- mouseDown:(NXEvent *)theEvent;
{	[super mouseDown:theEvent];
	[self preventBreakSelectionUp:-1];
	return self;
}

-(void) setAutomoveBy:(int) i
{	automoveBy=i;
}
-(void) setDidKey:(MiscMPageText_t) flag
{	didKey=flag;
}
-(MiscMPageText_t) didKey
{	return didKey;
}

- _replaceSel:p1:p2:p3:p4:p5:p6:p7
{	id erg;

	if(didKey)	// only for real typing
	{	[[self window] disableFlushWindow];
	}
	erg=[super _replaceSel:p1:p2:p3:p4:p5:p6:p7];
	if([window isFlushWindowDisabled])
	{	if(didKey!= MiscMPageText_backspace && didKey && ![delegate someBreakMoved])	// someBreakMoved:sideeffect
		{	[[window reenableFlushWindow] flushWindow];
		}
	} if(didKey!= MiscMPageText_backspace) didKey=0;	// MiscMPageText_backspace is handled in keyDown
	return erg;
}

- copy:sender
{	id erg;
	didKey=MiscMPageText_copy;
	erg=[super copy:sender];
	didKey=0;
	return erg;
}
- paste:sender
{	id erg;
	int oldPos=sp0.cp,i,add=0;
	didKey=MiscMPageText_paste;
	erg=[super paste:sender];
	didKey=0;
	[self preventBreakSelectionUp:2 offset:0];
	for(i=oldPos;i< sp0.cp;i++) if([self isPageBreakAt:i]) add++;
	[self setSel:sp0.cp+add:spN.cp+add];	// force caret-drawing
	return erg;
}
- delete:sender
{	id erg;
	didKey=MiscMPageText_simpleKey;
	erg=[super delete:sender];
	didKey=0;
	[self preventBreakSelectionUp:-3 offset:-2];
	[self setSel:sp0.cp:spN.cp];	// force caret-drawing
	return erg;
}

unsigned short MultiPageCharfilter(unsigned short charCode,int keyFlags,unsigned short charSet)
{	MultiPageText	*self=[[NXApp keyWindow] firstResponder];
	NXSelPt			 sp0,spN;

	[self getSel:&sp0:&spN];
	switch(NXFieldFilter(charCode,0,charSet))	// dont set it see the flags (esp.cntrl)
	{	case NX_LEFT:
			[self preventBreakSelectionUp:-2 offset:-2];
			if(keyFlags & NX_SHIFTMASK)
			{	if(sp0.cp == sp0.c1st) return 0;
				[self setSel:sp0.c1st+1:sp0.c1st+1];
			} else if(keyFlags & NX_CONTROLMASK)
			{	int 	pos=sp0.cp,c;
				while(pos && (c=[self charAt:--pos])>= 0 && !NXIsSpace(c)){}
				[self setSel:pos+1:pos+1];
				return NX_LEFT;		// default cntrl-crsr lets arrowos be inserted into text
			}
		break;
		case NX_UP:
			if(keyFlags & NX_SHIFTMASK)		//pageUp
				[[self delegate] pageUp:self];
		break;
		case NX_RIGHT:
			[self preventBreakSelectionUp:1 offset:0];
			if(keyFlags & NX_SHIFTMASK)
			{	int pos=spN.c1st+[self lengthOfLineForSel:&spN]-1;
				if(pos == spN.cp) return 0;
				[self setSel:pos-1:pos-1];
			} else if(keyFlags & NX_CONTROLMASK)
			{	int		pos=spN.cp,c;
				while((c=[self charAt:++pos])>= 0 && !NXIsSpace(c)){}
				[self setSel:pos-1:pos-1];
				return NX_RIGHT;
			}
		break;
		case NX_DOWN:
			[self setDidKey:MiscMPageText_down];
			if(keyFlags & NX_SHIFTMASK)		//pageDown
				[[self delegate] pageDown:self];
		break;
		case NX_BACKSPACE:		// fall thru
			if(keyFlags & NX_CONTROLMASK)	// delete curr. line
			{	if(sp0.cp == spN.cp)
					[self setSel:sp0.c1st:sp0.c1st+[self lengthOfLineForSel:&sp0]];
			} [self preventBreakSelectionUp:-2 offset:-2];	// fall thru
		default: [self setDidKey:MiscMPageText_simpleKey];	//_replaceSel recognices this
	} return ((NXCharFilterFunc)[[self delegate] oldCharFilter])(charCode,keyFlags,charSet);
}

@end
//--------------------------------------------------------------------

@implementation MultiPageController

- updateBreakList
{	id		currBreak;
	int		i;
	NXPoint loc;
	List   *removeList=[[List alloc] init];
	for(i=0;currBreak=[breakList objectAt:i];i++)
	{	if(![text getLocation:&loc ofCell:currBreak])
			[removeList addObject:currBreak];
	}
	for(i=0;currBreak=[removeList objectAt:i];i++) [breakList removeObject:currBreak];
	[removeList free];
	return self;
}


-(BOOL) isCell:(PageBreakCell*) theCell inSel:(int) cp0 :(int)cpN
{	int i=[self charIndexForPageBreak:theCell];
	if(cp0< i && cpN> i) return YES;
	else				 return  NO;
}

-(BOOL) someBreakMoved
{	id		currBreak;
	int		i;
	NXPoint	thePoint;

	[self updateBreakList];		// take care of users removal of some pagebreaks
	for(i=0;currBreak=[breakList objectAt:i];i++)
	{	[text getLocation:&thePoint ofCell:currBreak];
		if(thePoint.y!= [currBreak ypos]) return YES;
	} return  NO;
}


-(int) pageCount
{	[self updateBreakList];		// take care of users removal of some pagebreaks
	return [breakList count]+1;
}

-(List*) breakList
{	[self updateBreakList];		// take care of users removal of some pagebreaks
	return breakList;
}

- selectPageBreak:(PageBreakCell*) theCell
{	NXEvent			 postEvent = (NXEvent)*[NXApp currentEvent];
	NXPoint			 thePoint;
	NXSelPt			 sp0,spN;

	[[text window] disableDisplay];
	[text getLocation:&thePoint ofCell:theCell];
	thePoint.x=0;
	thePoint.y=MIN(thePoint.y+SEPERATOR_HEIGHT-1,[text maxY]-1);
	[text convertPoint:&thePoint toView:nil];
	postEvent.location =thePoint;
	postEvent.type = NX_MOUSEUP,postEvent.flags=0;
	DPSPostEvent(&postEvent, YES);
	postEvent.type = NX_MOUSEDOWN,postEvent.data.mouse.click = 3;
	[text mouseDown:&postEvent];
	[text getSel:&sp0:&spN];	// select exclusively the break
	[[text window] reenableDisplay];
	if(ABS(sp0.cp-spN.cp)> 2) [text setSel:spN.cp-2:spN.cp];

	return self;
}

-(int) charIndexForPageBreak:(PageBreakCell*) theCell
{	NXSelPt			 sp0,spN,peek;
	[[text window] disableFlushWindow];
	[[text window] disableDisplay];
	[text getSel:&sp0:&spN];

	[self selectPageBreak:theCell];
	[text getSel:&peek:&peek];


	[[text window] reenableDisplay];
	// reestablish selection (bitte unter reenableDisplay, der grafik zuliebe)
	[text setSel:sp0.cp:spN.cp];
	[[text window] reenableFlushWindow];
	return peek.cp;
}

-(PageBreakCell*) pageBreakOfIndex:(int) i
{	[self updateBreakList];
	return [breakList objectAt:i];
}
-(int) indexOfPageBreak:(PageBreakCell*) theCell
{	[self updateBreakList];
	return [breakList indexOf:theCell];
}
-(NXCoord) heightForIndex:(int) index
{	NXPoint			 thePoint;
	if(index> [self pageCount]-1) return -1;
	if(index==[self pageCount]-1 && [text getLocation:&thePoint
											   ofCell:[self pageBreakOfIndex:index-1]])
		return [text maxY]-thePoint.y;
	if([text getLocation:&thePoint ofCell:[self pageBreakOfIndex:index]])
	{	NXCoord y1=thePoint.y;
		if(!index) return y1;
		if([text getLocation:&thePoint ofCell:[self pageBreakOfIndex:index-1]])
			return y1-thePoint.y;
	}
	return -1;
}

-(int) movePageBreak:(PageBreakCell*) theCell toY:(NXCoord) theHeight
{	NXSelPt			 sp0,spN,peek0;
	NXEvent			 postEvent = (NXEvent)*[NXApp currentEvent];
	NXPoint			 thePoint;
	PageBreakCell	*newBreak=[theCell copy];
	int				 erg=0;

	[[text window] disableFlushWindow];
	[text getSel:&sp0:&spN];

	// delete old break
	[self selectPageBreak:theCell];
	[text replaceSel:""];

	// insert at new loc
	thePoint.x=0;
	thePoint.y=MIN(theHeight+SEPERATOR_HEIGHT-1,[text maxY]-1);
	[text convertPoint:&thePoint toView:nil];
	postEvent.location = thePoint;
	postEvent.type = NX_MOUSEUP,postEvent.flags=0;
	DPSPostEvent(&postEvent, YES);
	postEvent.type = NX_MOUSEDOWN,postEvent.data.mouse.click = 1;
	[text mouseDown:&postEvent];
	[text getSel:&peek0:&peek0];erg=peek0.cp;
	[text replaceSelWithCell:newBreak];
	[text replaceSel:"\n"];

	// reestablish selection
	[text setSel:sp0.cp:spN.cp];

	[[text window] reenableFlushWindow];
	if(![breakList replaceObject:theCell with:newBreak])
		[breakList addObject:newBreak];

	return erg;
}

-(PageBreakCell*) pageBreakForY:(NXCoord)someY
{	int		i;
	id		currBreak;

	[self updateBreakList];		// take care of users removal of some pagebreaks

	for(i=0; currBreak=[breakList objectAt:i] ;i++)
		if(someY== [currBreak ypos]) return currBreak;
	return nil;
}

-(int) indexOfcurrentPage
{	int		i;
	id		currBreak;
	NXPoint	thePoint;
	NXSelPt sp0,spN;

	[self updateBreakList];		// take care of users removal of some pagebreaks
	[text getSel:&sp0:&spN];
	for(i=0; currBreak=[breakList objectAt:i] ;i++)
	{	[text getLocation:&thePoint ofCell:currBreak];
		if(thePoint.y>= sp0.y)
		{	return i;
		}
	}	 if(!i) return 0;	// only one page?
	else if(!currBreak)		// was on very last page
		return [breakList count]-1;
		return  -1;
}
- selectPageOfIndex:(int) i
{	int pos=[self charIndexForPageBreak:[self pageBreakOfIndex:i]];
	[[text setSel:pos-1:pos-1] makeSelectionVisible];
	return  self;
}
- selectPage:sender
{	return [self selectPageOfIndex:[sender intValue]];
}

// rewrite for using above
- pageUp:sender
{	int		i;
	id		currBreak;
	NXPoint	thePoint;
	NXSelPt sp0,spN;

	[self updateBreakList];		// take care of users removal of some pagebreaks
	[text getSel:&sp0:&spN];
	for(i=0; currBreak=[breakList objectAt:i] ;i++)
	{	[text getLocation:&thePoint ofCell:currBreak];
		if(thePoint.y>= sp0.y)
		{	int pos=[self charIndexForPageBreak:[self pageBreakOfIndex:MAX(i-1,0)]];
			[text setSel:pos-1:pos-1];
			break;
		}
	}	 if(!i) [text setSel:0:0];
	else if(!currBreak)	// was on very last page
	{	int pos=[self charIndexForPageBreak:[self pageBreakOfIndex:[breakList count]-1]];
		[text setSel:pos-1:pos-1];
	} [text makeSelectionVisible];
	return  self;
}
- pageDown:sender
{	int		i;
	id		currBreak;
	NXPoint	thePoint;
	NXSelPt sp0,spN;

	[self updateBreakList];		// take care of users removal of some pagebreaks
	[text getSel:&sp0:&spN];
	for(i=0; currBreak=[breakList objectAt:i] ;i++)
	{	[text getLocation:&thePoint ofCell:currBreak];
		if(thePoint.y>= spN.y)
		{	int pos=[self charIndexForPageBreak:[self pageBreakOfIndex:i]];
			[text setSel:pos-1:pos-1];
			break;
		}
	} if(!currBreak) [text setSel:[text textLength]:[text textLength]];
	[text makeSelectionVisible];
	return  self;
}

- removePageBreak:(PageBreakCell*) theCell
{	NXSelPt			 sp0,spN;

	[[text window] disableFlushWindow];
	[text getSel:&sp0:&spN];

	[self selectPageBreak:theCell];[text replaceSel:""];
	[breakList removeObject:theCell];

	// reestablish selection
	[text setSel:sp0.cp:spN.cp];
	[[text window] reenableFlushWindow];

	return self;
}

-(void) registerPageBreak:(PageBreakCell*)newBreak
{	[breakList addObject:newBreak];
}

-(PageBreakCell*) insertPageBreak:sender
{	id			newBreak;
	NXSelPt		sp0,spN;
	NXPoint		thePoint;

	[[text window] disableFlushWindow];

	[text replaceSelWithCell:newBreak=[[PageBreakCell alloc] initForText:text
					 pageNum:[breakList count]+1]];
	[text replaceSel:"\n"];
	[text getLocation:&thePoint ofCell:newBreak];
	[newBreak setYpos:thePoint.y];
	[breakList addObject:newBreak];

	[text getSel:&sp0:&spN];
	[self selectPageBreak:newBreak];
	[text setSelProp:NX_FIRSTINDENT to:0];	// move to the left

	// reestablish selection
	[text setSel:sp0.cp:spN.cp];
	[[text window] reenableFlushWindow];

	return newBreak;
}
- insertPageBreakAtY:(NXCoord) theHeight
{	NXSelPt			 sp0,spN;
	NXEvent			 postEvent = (NXEvent)*[NXApp currentEvent];
	NXPoint			 thePoint;

	[[text window] disableFlushWindow];

	[text getSel:&sp0:&spN];

	// click at new loc
	[[text window] disableDisplay];
	thePoint.x=0;
	thePoint.y=MIN(theHeight+SEPERATOR_HEIGHT-1,[text maxY]-1);
	[text convertPoint:&thePoint toView:nil];
	postEvent.location =thePoint;
	postEvent.type = NX_MOUSEUP,postEvent.flags=0;
	DPSPostEvent(&postEvent, YES);
	postEvent.type = NX_MOUSEDOWN,postEvent.data.mouse.click = 1;
	[text mouseDown:&postEvent];
	[[text window] reenableDisplay];

	[self insertPageBreak:self];

	// reestablish selection
	[[text setSel:sp0.cp:spN.cp] makeSelectionVisible];
	[[text window] reenableFlushWindow];

	return self;
}

// the pageBreaks have to stand solid as rocks in the textflow
-(BOOL) rearrangePageBreaks
{	id		currBreak;
	int		i,breakIndex=0,oldBreakIndex=0;
	NXCoord y=0,peekY;
	NXPoint loc;
	BOOL	erg=NO,didInsert=NO;
	List   *removeList=[[List alloc] init];

	for(i=0;currBreak=[breakList objectAt:i];i++,oldBreakIndex=breakIndex)
	{  [[text window] disableDisplay];[text calcLine];
	   [[text window] reenableDisplay];
		[text getLocation:&loc ofCell:currBreak];
		if(loc.y!= (peekY=[currBreak ypos]))					// pageBreak moved?
		{	if(peekY ==0 || ([currBreak ypos]>= [text maxY]))	// useles or mission impossible?
				[removeList addObject:currBreak];				//  then remove this
			else if(peekY< 0) [currBreak setYpos:peekY=loc.y];	// refix ypos
			else
			{	breakIndex=[self movePageBreak:currBreak toY:peekY];
				currBreak=[breakList objectAt:i];// caveat: old currBreak freed
				if([currBreak didMoveManually])	// this is when user sligtly missed the line
				{	[text getLocation:&loc ofCell:currBreak];
					[currBreak setYpos:loc.y];
					[currBreak setDidMoveManually:NO];
				} else erg=YES;loc.y=peekY;
				if(ABS(oldBreakIndex-breakIndex)< 2)	// adjacent breaks?
					[removeList addObject:currBreak];
			}
		} y=loc.y+SEPERATOR_HEIGHT;
	}
	// nun den rest versorgen
	while([text maxY]-y> defHeight)
	{	[self insertPageBreakAtY:y+=(defHeight+SEPERATOR_HEIGHT*(i?1:0))];
		erg=didInsert=YES;
	}
	for(i=0;currBreak=[removeList objectAt:i];i++)
		[self removePageBreak:currBreak];
	[removeList free];
	if(didInsert) [text preventBreakSelectionUp:1 offset:-1];
	return erg;
}

- (NXCoord)defHeight
{	return defHeight;
}
- setDefHeight:(NXCoord)aDefHeight
{	defHeight=aDefHeight;
	return self;
}
-(void) installCharFilter:(NXCharFilterFunc) newFilter
{	oldCharFilter=[text charFilter];
	[text setCharFilter: newFilter];
}
-(void) installTextFilter:(NXTextFilterFunc) newFilter
{	oldTextFilter=[text textFilter];
	[text setTextFilter: newFilter];
}
-(NXCharFilterFunc) oldCharFilter {return oldCharFilter;}
-(NXTextFilterFunc) oldTextFilter {return oldTextFilter;}

- initForText:(Text*) theText withHeight:(NXCoord) height
{	if(!(self=[super init])) return nil;
	 breakList=[[List alloc] init];
	 defHeight=height;
	 text=theText;
	[Text registerDirective:"PageBreak" forClass: [PageBreakCell class]];
	 textDelegate=[text delegate];
	[text setDelegate:self];

	// for the pagebreak cell to look good, the left magin has to be 0
	[text selectAll:self];
//	[text setSelProp:NX_LEFTMARGIN	to:0.1];
//	[text setSelProp:NX_FIRSTINDENT	to:0.0];
//	[text setSelProp:NX_INDENT		to:0.0];

	[text becomeClass:[MultiPageText class]];
	[self installCharFilter:MultiPageCharfilter];
	[self installTextFilter:MultiPageTextfilter];

	return self;
}
- initWithDefaultHeightForText:(Text*) theText
{	const NXRect *paperRect=[[NXApp printInfo] paperRect];
	return [self initForText: theText withHeight:paperRect->size.height];
}


- free
{	[breakList free];
	return [super free];
}



- doRearrange:textObject
{	BOOL	was=[text isFontPanelEnabled];
	[text setFontPanelEnabled:NO];
	[self updateBreakList];		// check whether user deleted some pagebreaks
	[self rearrangePageBreaks];
	[text setFontPanelEnabled:was];
	if ( [[text window] isFlushWindowDisabled])
		[[[text window] reenableFlushWindow] flushWindow];
	return self;
}
- doRearrangeAndDisplay:textObject
{	[self doRearrange:textObject];
	[[text window] flushWindow];
	return self;
}

- textDidGetKeys:textObject isEmpty:(BOOL)flag
{	[self doRearrange:textObject];

	// pass thru delegation
	if(textDelegate && [textDelegate respondsTo:@selector(textDidGetKeys:isEmpty:)])
		[textDelegate textDidGetKeys:textObject isEmpty:flag];
	return self;
}

// pseudo-delegate method
- didChangeFontSize:sender
{	[self doRearrangeAndDisplay:sender];
	[[self breakList] makeObjectsPerform:@selector(setDidMoveManually:) with:(id)YES];
	return self;
}

- textWillConvert:sender fromFont:from toFont:to
{	[self perform:@selector(didChangeFontSize:) with:sender
							 afterDelay:0
						 cancelPrevious:NO];
	return to;
}

// user dclicked on PageBreakCell: by default display sort of inspector
- didDclickPageBreak:(PageBreakCell*)sender
{	if(NXRunAlertPanel("PageBreakInfo","PageNum: %d\n"
					   "Ypos: %5.2f\n"
					   "Valid:%s","OK","Delete",NULL,
					   [sender pageNum],[sender ypos],
					   [self indexOfPageBreak:sender] == NX_NOT_IN_LIST?"NO":"YES")
		== NX_ALERTALTERNATE)
	{	[self perform:@selector(removePageBreak:) with:sender
							 afterDelay:25			// sort of risky since this will free
						 cancelPrevious:NO];		// our caller
	} return self;
}

@end
